VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmSearch 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Stored Procedure Search"
   ClientHeight    =   6435
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7965
   Icon            =   "frmSearch.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6435
   ScaleWidth      =   7965
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect"
      Height          =   330
      Left            =   6525
      TabIndex        =   5
      Top             =   1350
      Width           =   1230
   End
   Begin MSComctlLib.ProgressBar pbProgress 
      Height          =   330
      Left            =   225
      TabIndex        =   14
      Top             =   6075
      Visible         =   0   'False
      Width           =   7530
      _ExtentX        =   13282
      _ExtentY        =   582
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.TextBox txtDBData 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Index           =   3
      Left            =   1935
      PasswordChar    =   "*"
      TabIndex        =   3
      Top             =   1395
      Width           =   4380
   End
   Begin VB.TextBox txtDBData 
      Height          =   285
      Index           =   2
      Left            =   1935
      TabIndex        =   2
      Top             =   1080
      Width           =   4380
   End
   Begin VB.TextBox txtDBData 
      Height          =   285
      Index           =   1
      Left            =   1935
      TabIndex        =   1
      Top             =   765
      Width           =   4380
   End
   Begin VB.TextBox txtDBData 
      Height          =   285
      Index           =   0
      Left            =   1935
      TabIndex        =   0
      Text            =   "(local)"
      Top             =   450
      Width           =   4380
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "Search"
      Height          =   330
      Left            =   6525
      TabIndex        =   7
      Top             =   2250
      Width           =   1230
   End
   Begin VB.TextBox txtSearch 
      Height          =   285
      Left            =   1935
      TabIndex        =   6
      Top             =   2295
      Width           =   4380
   End
   Begin VB.CheckBox chkTrusted 
      Caption         =   "Use Integrated Security"
      Height          =   330
      Left            =   1935
      TabIndex        =   4
      Top             =   1755
      Width           =   3075
   End
   Begin VB.ListBox lstSP 
      Height          =   2985
      Left            =   180
      TabIndex        =   8
      Top             =   2745
      Width           =   7575
   End
   Begin VB.Label lblConnectedLabel 
      Caption         =   "Connected to"
      Height          =   285
      Left            =   180
      TabIndex        =   17
      Top             =   135
      Width           =   1725
   End
   Begin VB.Label lblConnected 
      Caption         =   "<not connected>"
      Height          =   285
      Left            =   1935
      TabIndex        =   16
      Top             =   135
      Width           =   4380
   End
   Begin VB.Label lblProgress 
      Caption         =   "Ready."
      Height          =   285
      Left            =   225
      TabIndex        =   15
      Top             =   5850
      Width           =   7530
   End
   Begin VB.Label lblDBData 
      Caption         =   "Password"
      Height          =   240
      Index           =   3
      Left            =   180
      TabIndex        =   13
      Top             =   1440
      Width           =   1770
   End
   Begin VB.Label lblDBData 
      Caption         =   "User Name"
      Height          =   240
      Index           =   2
      Left            =   180
      TabIndex        =   12
      Top             =   1125
      Width           =   1770
   End
   Begin VB.Label lblDBData 
      Caption         =   "Database"
      Height          =   240
      Index           =   1
      Left            =   180
      TabIndex        =   11
      Top             =   810
      Width           =   1770
   End
   Begin VB.Label lblDBData 
      Caption         =   "Server"
      Height          =   240
      Index           =   0
      Left            =   180
      TabIndex        =   10
      Top             =   495
      Width           =   1770
   End
   Begin VB.Label lblSearch 
      Caption         =   "Search For"
      Height          =   240
      Left            =   180
      TabIndex        =   9
      Top             =   2340
      Width           =   1770
   End
End
Attribute VB_Name = "frmSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'::: Module    : frmSearch
'::: DateTime  : 4/13/2004 15:30
'::: Author    : Eric_Anderson
'::: Purpose   :
':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
Option Explicit

Public Enum DBData
  eServer = 0
  eDatabase = 1
  eUserName = 2
  ePassword = 3
End Enum

Private m_oServer As SQLDMO.SQLServer2
Private m_oDatabase As SQLDMO.Database2
Private m_bStopSearch As Boolean
Private m_bAppClose As Boolean

':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'::: Procedure : Form_Unload
'::: DateTime  : 4/13/2004 16:44
'::: Author    : Eric_Anderson
'::: Purpose   :
':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
':::
Private Sub Form_Unload(Cancel As Integer)

  On Error GoTo Form_Unload_Error

  '::: Indicate the search is over
  m_bStopSearch = True
  m_bAppClose = True
  
  '::: Clean up
  If Not m_oServer Is Nothing Then
    m_oServer.Close
    Set m_oServer = Nothing
  End If
  
  If Not m_oDatabase Is Nothing Then
    Set m_oDatabase = Nothing
  End If
  
  On Error GoTo 0
  Exit Sub

Form_Unload_Error:

  MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure Form_Unload of Form frmSearch"
End Sub

':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'::: Procedure : cmdConnect_Click
'::: DateTime  : 4/13/2004 16:39
'::: Author    : Eric_Anderson
'::: Purpose   :
':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
':::
Private Sub cmdConnect_Click()

  On Error GoTo cmdConnect_Click_Error

  Dim iCurrentPointer As Integer
  Dim bOK As Boolean
  
  '::: Set the wait state and disable the other buttons
  iCurrentPointer = Me.MousePointer
  Me.MousePointer = vbHourglass
  Me.cmdConnect.Enabled = False
  Me.cmdGo.Enabled = False
  
  '::: Open away
  bOK = DBConnect()
  
cmdConnect_Click_End:
  '::: REturn the original state
  Me.MousePointer = iCurrentPointer
  Me.cmdConnect.Enabled = True
  Me.cmdGo.Enabled = True
  
  On Error GoTo 0
  Exit Sub

cmdConnect_Click_Error:

  MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure cmdConnect_Click of Form frmSearch"
  Resume cmdConnect_Click_End
  
End Sub

':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'::: Procedure : cmdGo_Click
'::: DateTime  : 4/13/2004 15:31
'::: Author    : Eric_Anderson
'::: Purpose   :
':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
':::
Private Sub cmdGo_Click()

  On Error GoTo cmdGo_Click_Error

  Dim bOK As Boolean
  
  '::: If this was called while the text of the button is "Stop Search" then set the cancel flag to true
  If LCase(Me.cmdGo.Caption) = "stop search" Then
    '::: indicate the search must stop and disable the button
    m_bStopSearch = True
    Me.cmdGo.Enabled = False
    
  Else
    '::: Start a search if we have a passed in search string
    If Len(Trim(Me.txtSearch.Text)) > 1 Then
      '::: hourglass
      Me.MousePointer = vbHourglass
      
      '::: Clear the last list
      Me.lstSP.Clear
      bOK = True
      
      '::: if the server or database is nothing, then connect
      If (m_oServer Is Nothing) Or (m_oDatabase Is Nothing) Then
        bOK = DBConnect()
      ElseIf (LCase(m_oServer.Name) <> LCase(Me.txtDBData(eServer).Text)) Or _
             (LCase(m_oDatabase.Name) <> LCase(Me.txtDBData(eDatabase).Text)) Then
        '::: We have a connection, but the user changed the connection information...
        bOK = DBConnect()
      End If
      
      '::: Only proceed with the search if we have the OK
      If bOK Then
        '::: Set the text of the button
        Me.cmdGo.Caption = "Stop Search"
        
        '::: Call the search
        Call GoSearch(Me.txtSearch.Text)
        
        '::: Reset the text of the button and re-enable it
        Me.cmdGo.Caption = "Search"
      End If
      
      Me.cmdGo.Enabled = True
      
      '::: hide the progress bar
      Me.pbProgress.Visible = False
    
      '::: reset the hourglass
      Me.MousePointer = vbDefault
    End If '::: if len(...) > 1
  End If '::: if Stop Search
  
cmdGo_Click_End:
  On Error Resume Next
  
  '::: Check to see if we need to end the application
  '::: this might happen if we recieve a form_unload while
  '::: processing a Search
  If m_bAppClose Then
    End
  End If
  
  Exit Sub

cmdGo_Click_Error:

  MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure cmdGo_Click of Form frmSearch"
  Resume cmdGo_Click_End
  
End Sub

':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'::: Procedure : lstSP_DblClick
'::: DateTime  : 4/13/2004 16:26
'::: Author    : Eric_Anderson
'::: Purpose   :
':::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
':::
Private Sub lstSP_DblClick()

  On Error GoTo lstSP_DblClick_Error

  Dim fSP As frmSP
  Dim oSP As SQLDMO.StoredProcedure2
  
  '::: Load the selected stored procedure's text into the SP form
  If Len(Me.lstSP.List(Me.lstSP.ListIndex)) > 0 Then
    
    '::: Get the stored procedure
    Set oSP = m_oDatabase.StoredProcedures(Me.lstSP.List(Me.lstSP.ListIndex))
    
    '::: Create a form and load the SQL
    Set fSP = New frmSP
    With fSP
      '::: Capture the Search string to search for
      .m_sSearch = Me.txtSearch.Text
      .lblName.Caption = oSP.Name
      .txtSQL.Text = oSP.Text
      
      '::: Show it
      .Show vbModal
      
    End With
    
  End If

  On Error GoTo 0
  
  '::: Cleanup
  Unload fSP
  Set fSP = Nothing
  
  Exit Sub

lstSP_DblClick_Error:

  MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure lstSP_DblClick of Form frmSearch"
End Sub

'---------------------------------------------------------------------------------------
' Procedure : chkTrusted_Click
' DateTime  : 4/13/2004 22:29
' Author    : Administrator
' Purpose   :
'---------------------------------------------------------------------------------------
'
Private Sub chkTrusted_Click()

  On Error GoTo chkTrusted_Click_Error

  '::: Enable/Disable the UserName/Password fields based on Integrated security
  Me.txtDBData(eUserName).Enabled = Not (chkTrusted.Value = vbChecked)
  Me.txtDBData(ePassword).Enabled = Not (chkTrusted.Value = vbChecked)
  
  On Error GoTo 0
  Exit Sub

chkTrusted_Click_Error:

  MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure chkTrusted_Click of Form frmSearch"
End Sub

'---------------------------------------------------------------------------------------
' Procedure : DBConnect
' DateTime  : 4/13/2004 22:34
' Author    : Administrator
' Purpose   :
'---------------------------------------------------------------------------------------
'
Private Function DBConnect() As Boolean

  On Error GoTo DBConnect_Error

  '::: First, clear out the connection objects
  If Not m_oServer Is Nothing Then
    m_oServer.Close
    Set m_oServer = Nothing
  End If
  
  If Not m_oDatabase Is Nothing Then
    Set m_oDatabase = Nothing
  End If
  
  '::: try to connect to the server and database
  
  '::: Open a connection to the Server if it isn't already open
  Me.lblProgress.Caption = "Connecting to the server."
  Me.lblProgress.Refresh
  
  Set m_oServer = CreateObject("SQLDMO.SQLServer2")

  '::: use integrated security if checked
  If Me.chkTrusted.Value = vbChecked Then
    m_oServer.LoginSecure = True
    m_oServer.Connect Me.txtDBData(eServer).Text
  Else
    m_oServer.LoginSecure = False
    m_oServer.Connect Me.txtDBData(eServer).Text, Me.txtDBData(eUserName).Text, Me.txtDBData(ePassword).Text
  End If
  
  '::: Open the database
  Me.lblProgress.Caption = "Opening the database."
  Me.lblProgress.Refresh
  Set m_oDatabase = m_oServer.Databases(Me.txtDBData(eDatabase).Text)
  
  '::: indicate success
  Me.lblProgress.Caption = "Database opened."
  Me.lblProgress.Refresh
  
  '::: update the connected label:
  Me.lblConnected = "Server: " & m_oServer.Name & "  --  Database: " & m_oDatabase.Name
  Me.lblConnected.Refresh
    
  '::: Return success
  DBConnect = True

DBConnect_End:
  On Error GoTo 0
  
  Exit Function

DBConnect_Error:

  MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure DBConnect of Form frmSearch"
  
  '::: Return failure
  DBConnect = False
  Me.lblProgress.Caption = "Connection to server/database failed!"
  
  Resume DBConnect_End
  
End Function

'---------------------------------------------------------------------------------------
' Procedure : GoSearch
' DateTime  : 4/13/2004 22:10
' Author    : Administrator
' Purpose   :
'---------------------------------------------------------------------------------------
'
Private Sub GoSearch(ByVal sSearch As String)

  On Error GoTo GoSearch_Error
  
  Dim oSP As SQLDMO.StoredProcedure2
  
  '::: Indicate the search is on
  m_bStopSearch = False
  
  '::: Initialize the progress bar
  Me.lblProgress.Visible = True
  Me.pbProgress.Visible = True
  
  '::: initialize the progress bar
  Me.pbProgress.Min = 0
  Me.pbProgress.Max = m_oDatabase.StoredProcedures.Count
  Me.pbProgress.Value = 0
    
  '::: Go through all of the Stored Procedures
  For Each oSP In m_oDatabase.StoredProcedures
  
    '::: Update the label and the progress bar
    Me.lblProgress.Caption = "Processing " & oSP.Name
    Me.lblProgress.Refresh
    Me.pbProgress.Value = Me.pbProgress.Value + 1
    Me.pbProgress.Refresh
    
    '::: Look for the search string in the Stored Procedure text
    If oSP.Encrypted = False Then
      If InStr(1, oSP.Text, sSearch, vbTextCompare) > 0 Then
        lstSP.AddItem oSP.Name
      End If
    End If
    
    '::: To allow for other processing
    DoEvents
    
    '::: Need to capture if the user closes the form and add a STOP SEARCH capability
    If m_bStopSearch Then
      Me.lblProgress.Caption = "Search canceled by user."
      GoTo GoSearch_End
    End If
    
  Next

  '::: Indicate complete
  Me.lblProgress.Caption = "Done."

GoSearch_End:
  On Error Resume Next
  
  '::: Memory cleanup
  Set oSP = Nothing
  
  Exit Sub

GoSearch_Error:

  MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure GoSearch of Form frmSearch"
  Resume GoSearch_End
  
End Sub
